
CREATE OR REPLACE FUNCTION spserviceorder_new(_svcrcvno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE 
	_retval		SPStatus%ROWTYPE;
	_ItemId    	svcrcvditem.itemid%TYPE;
	_Pid    	svcrcvditem.pid%TYPE;
	_Whid    	svcrcvditem.whid%TYPE;
	_spret	        SPStatus%ROWTYPE;
	_refno          VARCHAR(30);
	_svcpartno	INT;
	_index		INT;
	cData		REFCURSOR;
	
BEGIN
	_retval:=(0,'OK');
	
	OPEN cData FOR
	SELECT itemid , pid, whid
	FROM svcrcvditem
	WHERE svcrcvno = _svcrcvno;
	
	LOOP
		FETCH cData INTO _ItemId, _Pid, _Whid;
		EXIT WHEN NOT FOUND;
		--INSERT INTO stock(itemid,pid,whid,qty) VALUES(_ItemId,_Pid,_Whid, 1);
	END LOOP;
	CLOSE cData;

	_index := 0;
	OPEN cData FOR
	SELECT refno,svcpartno
	FROM svcpart
	WHERE svcrcvno = _svcrcvno
	ORDER BY svcpartno;
	
	LOOP
		FETCH cData INTO _refno,_svcpartno ;
		EXIT WHEN NOT FOUND;

		IF(_refno IS NOT NULL) THEN
			IF NOT EXISTS(SELECT 1 FROM sale WHERE saleno=_refno) THEN
				_retval.ErrNo:=50001;
				_retval.ErrMsg='No. Penjualan : '||COALESCE(_refno,'<kosong>')||' sudah dihapus (spserviceorder_new)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;

		--Renumbering SvcPart And Update ke SaleD yang relevan
		_index := _index +1;
		UPDATE svcpart SET svcpartno = _index WHERE svcpartno = _svcpartno AND svcrcvno = _svcrcvno;
		IF(_refno IS NOT NULL) THEN
			UPDATE saled SET svcpartno = _index WHERE svcpartno = _svcpartno AND saleno=_refno;
		END IF;


	END LOOP;
	CLOSE cData;

	RETURN NEXT _retval;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;


ALTER TABLE svcrcv ADD branchid CHARACTER VARYING(5);
ALTER TABLE svcrcv ADD CONSTRAINT fk_branch_rel_serv FOREIGN KEY (branchid) REFERENCES branch (branchid) ON DELETE RESTRICT ON UPDATE CASCADE;
ALTER TABLE svcrcv ADD CrtBy CHARACTER VARYING (10);
ALTER TABLE svcrcv ADD CrtDate TIMESTAMP;
ALTER TABLE svcrcv ADD UpdBy CHARACTER VARYING (10);
ALTER TABLE svcrcv ADD UpdDate TIMESTAMP;
ALTER TABLE svcrcv ALTER COLUMN bpid type CHARACTER VARYING (20);
ALTER TABLE svcrcv ALTER COLUMN bpname type CHARACTER VARYING (50);

